/* yasep/tool/yasim.js
 created ven. oct.  5 06:38:36 CEST 2012 by whygee@f-cpu.org
 lun. oct.  8 21:49:12 CEST 2012 : renamed from simul.js
*/

/*
function tagFocus(){
  ygwm.focus_window(null,this.win);
  return false;
}

//<font color=\"red\" size=\"+2\"><b> \u27A1";
//
// \u1405  \u2192  \u21D2  \u22B3  \u21F0  \u2326  \u232B  \u261B"
//      +" \u2794 \u2799 \u279B \u279C \u279D \u279E \u279F \u27A0 \u27A1 \u27A2"
//      +" \u27A4  \u27A8 \u2907 \uFFEB";
//x1405 ᐅ
//x2192 →
//x21D2 ⇒ 
//x22B3 ⊳
//x21F0 ⇰
//x2326 ⌦
//x232B ⌫
//x261B ☛ 
//x2790 ➔ ➙ ➛ ➜ ➝ ➞ ➟
//x27A4 ➤
//x27A8 ➨
//x27A0 ➠ ➡ ➢ ➣ ➤ ➥ ➦ ➧ ➨ ➩ ➪ ➫ ➬ ➭ ➮ ➯
//x27B0 ➱ ➲ ➳ ➵ ➶ ➷ ➸ ➹ ➺ ➻ ➼ ➽ ➾
//x2907 ⤇
//x2900 and on...
//x2B00 ...
//xFFEB  ￫

Drag&drop du curseur pour faire avancer le programme ?
*/



////////////////////////////////////////////////////////////

init_obj.push(sim={

  simCount:1,

//////
  showhideNext:function() {
    toggle(this.nextSibling);
  },

///////////// floating cursor :
  create_cursor: function(col,cont,omd,w){
    var c=dcE("DIV");
    c.win=w;
    c.className="tag";
    c.style.color=col;
    c.innerHTML=cont+"<font size=\"+2\"><b>\u27A1</b></font>";
    c.onmousedown=omd;
    return c;
  },


///////////// Finite State Machine :
  states:["INIT", "RUN", "STEP", "STOP", "HALT", "FAULT"],
  // The actual state is stored in win.state

  showState: function(w) {
    w.shortmsg("&nbsp;Status:&nbsp;<i>"+sim.states[w.state]+"</i>");
/*
      d.innerHTML+=" &nbsp;&nbsp;Status:&nbsp;";
      d.appendChild(win.StatId=dcE("SPAN"));
      win.StatId.style.fontStyle="italic";

    w.StatId.innerHTML=sim.states[w.state];*/
  },

  resetState: function(e,t) {
    t=t||this;
    var i, w=parentWin(t);

    w.cycle_id.innerHTML
      =w.cycle
      =w.state
      =0;
    sim.showState(w);

    for (i in w.regs){
      w.regs[i]=null;
      w.regs_id[i].innerHTML="u";
      w.regs_id[i].id=""; //bgcolor
    }
    sim.flushChanges(0,w);

    sim.regWrite(w,0,0);
    w.Carry
   =w.Zero
   =0;
    w.Carry_id.checked
   =w.Zero_id.checked
   =false;

    sim.updateASM(w); // hide



    // Clear history


  },

  flushChanges: function(e,t) {
    t=t||this;
    var i, w=parentWin(t);
    for (i in w.regs)
      w.regs_changed[i].innerHTML="";  // flush the bullet
  },

///////////// Profiles :
  change_profile: function(a,w) {
    if(typeof a!="string"){
      // when called from changing the selector
      var t=this;
      if(w)
        t=w.ProfileSel;
      else
        w=parentWin(t);
      a=t.options[t.selectedIndex].text;
    }
    else {
      var found=false;
      if (typeof profiles[a]!="object")
        return Al8N("Ipn");
      var i,sel=w.ProfileSel;
      for (i in sel.options) {
        if (sel.options[i].text==a) {
          found=true;
          break;
        }
      }
      if (!found) {
        // new profile added by the user since last click ?
        i=sel.options.length;
        sel.options[i]=new Option(a);        
      }
      sel.selectedIndex=i;
    }
    w.profileName=a;

    var m=0, b=profiles[a].datapath;
    if (w.bpBits != a) {
      w.DISASM.YASEP_TYPE
        =w.bpBits
        =b;
      while (b--)  // iterative mask creation because
        m+=m+1;    // 1<<32 == 1 !!! (5 LSB kept)
      w.bpMask=m;

      // check all the inputs under w.BPdiv, in case they are now out of range
      var l=w.BPdiv.getElementsByTagName("INPUT");
      for (b in l)
        if (l[b].id=="num")
            l[b].onkeyup();

//    update/redraw register values with new mask
      sim.redisReg(w);

//  this could change the cursor position in YASMed !
    }
  },

  update_proflist:function(u,t) {
    t=t||this;
    var p,s=t.selectedIndex,i=0;

    for (p in profiles) {
      // the position is reset to 0 each time the list is changed,
      // which makes some weird visual inconsistencies,
      // so update only if really needed (but does not really solve the "bug")
      // listBlur helps too.
      if (!t.options[i] || (t.options[i].text!=p))
        t.options[i]=new Option(p);
      i++;
    }
    t.selectedIndex=s>0?s:0; // by default s is -1 ?...
//    if(t
//     =parentWin(t))
//       t.prof.innerHTML=" "+t.selectedIndex;
  },

  listBlur:function(){ // prevents a visual bug...
    var w=parentWin(this);
    sim.change_profile(w.profileName,w);
  },


/////////////// Radix
  chBase: function(t){
    var i, w=parentWin(t);
    w.num_func=sim["num_"+t.value];
    sim.redisReg(w);
  },

  num_bin: function(n,d){
    return toBin(n,d,1)+"b";
  },

  num_dec: function(n){
    return n;
  },

  num_hex: function(n){
    return int2hex(n);
  },

  redisReg: function(w){
    var r;
    for (i in w.regs){
      r=w.regs[i];
      w.regs_id[i].innerHTML=
         r!==null ? w.num_func(w.regs[i] & w.bpMask, w.bpBits) : "u";
    }
  },
/*
  clearRegs: function(w){
    for (i in w.regs){
      w.regs[i]=null;
      w.regs_id[i].innerHTML="u";
    }
  },
*/
/////////////// Register history

  displayRegHistory: function(n,w){
    if (!w){
      n=this.nr;
      w=parentWin(this);
    }
    w.regName.innerHTML=Y.registers_names[n];
//       win.HistoDiv
  },

  createRegHistory: function(nr,nm){
// <u>History of Register :</u>
  },


////////////// Register write
  regWrite: function(w,r,v) {

// check that r >= 0 and <16
    r&=15;

// check that value >= 0 and <= bitMask
    v&=w.bpMask;
// The LSB of the PC is always 0:
    if (!r) {
//      if (v&1)
//        traceLog("attempt to write to PC's LSB");
      v&= ~1;
    }

    // if equal, don't log ?
    if(w.regs[r]!=v){

      // update the register value in w.regs
      w.regs[r]=v;

      // display the value
      w.regs_id[r].innerHTML=w.num_func(v,w.bpBits);

      // Change the background color if it's a A register that is parked
      if ((r>6)&&(r&1)) // A register ?
/*     { // compute the parking address
        var p=r>>1, b="";
        if (v== p|(w.bpMask&~7))
          b="P";
        w.regs_id[r].id=b;
      } */
        w.regs_id[r].id= (v==((w.bpMask&~7)|(r>>1))) ?"P":"";

      //toggle the "changed" flag
      w.regs_changed[r].innerHTML="\u25CF";

      // update the trace log
       // (if visible)

      // scan the breakpoint list

    }
  },

  checkRegister:function(t){
    if(t.value=="u")
       t.value=0;
    var  n
      =sim.numval
      =str2int(t.value),
    w=sim.pw||(sim.pw=parentWin(edit_text.current_elem)),
    m=w.bpMask+1;
    edit_text.valid=!((n===null)||(n>=m)||(n<(m/-2)));
  },

  validRegister:function(t){ // normally, the sim.numval is correct because save is turned on when valid==true
    sim.regWrite(sim.pw, t.rn, sim.numval);

    sim.pw.shortmsg(sim.numval);
    // erase source so innerHTML will be re-read next time after update by sim
    t.source
      =sim.pw
      =null;
  },

////////////// Carry & Zero
///          e.onchange=sim["click"+name];
///          td.onclick=sim["display"+name];

  changeCarry:function(v) {
  },

  changeZero:function(v) {
  },

  clickCarry:function(v) {
  },

  clickZero:function(v) {
  },

  displayCarry: function(n,w){
  },

  displayZero: function(n,w){
  },




/////////////// breakpoints (low level API)
/*
 // TODO : detect duplicate breakpoints

  addBr_cycle:function(w,cycle) {
  },

  addBr_addr:function(w,addr) {
  },

  addBr_valReg:function(w,val,reg) { // passe la valeur en négatif
  },

  toggleBr:function(w,br) { // passe la valeur en positif / négatif
  },

  deleteBr:function(w,br) {
  },

  changeBPval:function(w,br,val) {
  },

  changeBPreg:function(w,br,reg) {
  },
*/
/////////////// breakpoints display / interface

  addNewBP:function(d,v){
    v.stopPropagation();
    var e,f;
    (e=dcE("DIV")).className="BPitem";
     e.id="off";

       f=dcE("DIV");
       f.className="minus";
       f.onclick=sim.deleteBP;
       f.title="delete this breakpoint";
     e.appendChild(f);

       f=dcE("INPUT");
       f.type="checkbox";
       f.title="enable/disable this breakpoint";
       f.onchange=sim.click_toggleBr;
     e.active_id=f;
     e.appendChild(f);

    d.appendChild(e);
    d.style.display="block";

    d.total_id.innerHTML= ++d.total;
    return e;
  },

  checkNumber: function(ev){
    var t=this,
      d=t.parentNode,
      w=parentWin(d),
      m=w.bpMask+1,
      n=str2int(t.value);
      a=d.active_id;
    // disables the breakpoint
    if(a.checked){
       a.checked=false;
       a.onchange();
     // note : it can be de-checked only if it was checked before,
     // meaning that t.parentNode.number was != null
     // so click_toggleBr executes the correct branch
     // (even when we just cleared the box)
    }
    if ((n===null)||(n>=m)||(n<(m/-2))) {
      n=null;
      t.style.backgroundColor="#F65";
    }
    else
      t.style.backgroundColor="";
    t.parentNode.number=n;
  },

  addNumberField:function(){
    var e=dcE("INPUT");
    e.id="num";
    edit_text.register(e, {
      size:10, maxsize:33,
      defaultValue: "0",
      func:sim.checkNumber
    });
    return e;
  },

  deleteBP:function(e,t){
    t=(t||this);
    var u=t.parentNode, // the breakpoint div
        d=u.parentNode; // container div
    d.total_id.innerHTML= --d.total;
    if (t.nextSibling.checked)
      d.active_id.innerHTML= --d.active;
    d.removeChild(u);
  },

  click_addBr_cycle:function(e,t) {
    t=t||this;
    var w=parentWin(t),
        i=w.BPcycle_id,
        d,f;
    d=sim.addNewBP(i,e);
    d.appendChild(sim.addNumberField());
  },

  click_addBr_addr:function(e,t) {
    t=t||this;
    var w=parentWin(t),
        i=w.BPaddr_id,
        d,f;
    d=sim.addNewBP(i,e);
    d.appendChild(sim.addNumberField());
  },

  click_addBr_valReg:function(e,t) { // passe la valeur en négatif
    t=t||this;
    var w=parentWin(t),
        i=w.BPvalReg_id,
        d,s;
    d=sim.addNewBP(i,e);

    d.appendChild(s=sim.regSel.cloneNode(true));
    s.selectedIndex=1;
    d.appendChild(s=sim.relSel.cloneNode(true));
    s.selectedIndex=2;
    d.appendChild(sim.addNumberField());
  },

  click_toggleBr:function(e,t) { // passe la valeur en positif
    t=t||this;
    var p=t.parentNode,
        d=p.parentNode;
    if(p.number!==null){ // 
      d.active_id.innerHTML // houba !
        =(d.active+= t.checked?1:-1);
/*
      if (t.checked){
// activate the proper BP with the new value

      }
      else{
// disables
      }
*/
    }
    else // trying to click when invalid?
      t.checked=false; // force the checkbox back
  },
/*
  click_deleteBr:function(e,t) {
    t=t||this;
  },
*/

//////////////////////

  updateASM:function(w,a){
    if (typeof a=="number"){
// size chop:
      if (a&1)
        a&=F8;
      else
        a&=F4;

      w.Disas_div.style.visibility="visible";
      w.Disas_hex.innerHTML=int2hex(a);
      w.Disas_msg.innerHTML="";

      if (profiles[w.profileName].valid[a&252]){ // 63<<2
        // disassemble the word
        w.Disas_out.style.backgroundColor="#DFD"; // reset color
        Y.DISASM(a,w.DISASM);
        w.Disas_out.innerHTML=w.DISASM.instruction;
      }
      else{
        w.Disas_out.style.backgroundColor="orange";
        w.Disas_out.innerHTML="invalid";
      }

    } else
      w.Disas_div.style.visibility="hidden";
  },

  assemble:function(e){
    winman.activate_window("ASM/asm#a?"+this.innerHTML);
  },

//////////////////////////////////////////////////////////////////////////////////////////
/////////////// Building a window
  start: function() {
    var cont=dcE("DIV"),
      w = ygwm.new_window(
         "YASim "+sim.simCount, null, cont,
         450, 450, 130, 100, false, true, true, true, false, "ms2_yelo"),
      c, d, f, i, p, tt,tb,tr,td, sel=dcE("SELECT");

//    w.bpMask=F4;  set at the end by a call to change_profile
//    w.bpBits=16;

       (d=dcE("DIV")).innerHTML='<font color="red">'+WARN+'WORK IN PROGRESS</font>';
    cont.appendChild(d);

/////// Top :

    function h3(n){
        (f=dcE("DIV")).innerHTML=I8N(n);
        f.className="simTitle";
        f.onclick=sim.showhideNext;
      cont.appendChild(f);
      cont.appendChild(d); // YES, d must be created BEFORE calling h3 and the code looks reversed
    }

    (e=dcE("DIV")).className="tagArea";
     e.title="Drag&Drop the arrow to the YASMed line\nwhere you want to execute code";
     e.appendChild(sim.create_cursor("red",sim.simCount,null));

    cont.appendChild(e);


    function button(c,f,t){
      (e=dcE("BUTTON")).innerHTML=c;
      e.onclick=f;
      if(t)
        e.title=t;
      d.appendChild(e);
    }

    w.state=sim.INIT;
      d=dcE("DIV");
      button("\u21E4",sim.resetState,"Reset"); //x21E4 ⇤ reset
      button("\u25B6",null,"Run");         //x25B6 ▶  run
      button("\u25ae\u25ae",null,"Pause"); //x25ae ▮  X2 =>pause
      button("\u25FC",null,"Stop");        //x25FC ◼ stop
// others :
//x21BB ↻ ? redo ?
//x21FB  ⇻ ?
//x2933  ⤳  skip over function calls
      (e=dcE("SPAN")).innerHTML="&nbsp;Cycle&nbsp;#";
      d.appendChild(e);

/*      (e=w.cycle_id
        =dcE("SPAN")).innerHTML
            =w.cycle   // Set in the reset function
            =0;*/
      d.appendChild(w.cycle_id=dcE("SPAN"));

      d.appendChild(dcE("BR"));

      button("\u21B7",null,"Step");        //x21B7 ↷ step
      button("\u21B7\u21B7\u21B7",null,"Step X cycles");

      (e=dcE("SPAN")).innerHTML="&nbsp;steps:";
      d.appendChild(e);
      d.appendChild(e=dcE("INPUT"));
      edit_text.register(e, {
        size:4, maxsize:4,
        defaultValue: "10",
        func: function(ev){
          var t=this;
          edit_text.filter_number(t);
          var n=str2int(t.value);
          if (n<2)
              n=2;
          parentWin(t).skipCycles
            =t.value
            =n;
        }});
    w.skipCycles=10;
//    sim.showState(w);   ///////////////////////////////:
    cont.appendChild(d);

/// Disassembler
      (e=dcE("DIV")).innerHTML='Instruction:&nbsp;<span id="hex">u</span>=<a style="cursor:pointer" class="asm_active" id="disas"> </a> &nbsp; <span id="msg"></span>';
      (w.Disas_div=e).style.margin="2px";
    d.appendChild(e);
    (w.Disas_out=getById("disas","A",e)).onclick=sim.assemble;
     w.Disas_hex=getById("hex","SPAN",e);
     w.Disas_msg=getById("msg","SPAN",e);

    w.DISASM= new Y.DISASM_context(function(col,msg){ // closure, but can't avoid it simply
      if(col!="blue"){
        w.Disas_out.style.backgroundColor=col;
        w.Disas_msg.innerHTML=msg;
      }
    });


/////// Configuration

      (d=dcE("DIV")).innerHTML=I8N("prf")+":&nbsp;";
        // profile selector
        sel.onblur=sim.listBlur;
      d.appendChild(
        w.ProfileSel=sel);

/*
// source :
        (e=dcE("DIV")).innerHTML="Source : ☑JS <strike>GHDL</strike> <strike>YCD</strike>";
      d.appendChild(e);

 // JS: selecteur de YASMed
 // GHDL
 // YCD

// import/export config
*/

    h3("cnf");


/////// Registers

    w.regs_changed=[];
    w.regs=[];
    w.regs_id=[];
      (tt=dcE("TABLE")).style.fontFamily="monospace";
       tt.style.textAlign="right";
       tt.style.borderSpacing="0px";
       tt.appendChild(tb
         =dcE("TBODY"));
       c='<th onclick="sim.flushChanges(0,this)" title="'+
           "flush the flags"
         +'"style="cursor:pointer">\u2260</th><th>Reg</th><th>&nbsp;Value&nbsp;</th><th>&nbsp;</th>';
       (tr=dcE("TR")).innerHTML=c+c
          +'<td id="histoReg" rowspan="18" style="padding:5px; border:1px solid #999; text-align:left; overflow: auto;'
          +'vertical-align:top"><u>History&nbsp;of&nbsp;<span id="regName"></span>:</u><div id="HistoDiv">cycle:adresse:valeur</td>';
       tb.appendChild(tr);
       w.regName=getById("regName","SPAN",tr);
       w.HistoDiv=getById("HistoDiv","SPAN",tr);
       sim.displayRegHistory(0,w);

       for (i in Y.registers_names){
         w.regs[i]=null;
         c=Y.registers_names[i];

////       w.XXX = sim.createRegHistory(i,c);
         if(!(+i & 1))
           tr=dcE("TR");

           (td=dcE("TD")).className=c[0];
         tr.appendChild(
              w.regs_changed[i]=td);

           (td=dcE("TD")).className=c[0];
           td.innerHTML=c+":";
           td.title="Click to view the last values";
           td.style.cursor="pointer";
           td.nr=+i; //passes the argument through "this"
           td.onclick=sim.displayRegHistory;
           td.style.padding="1px";
         tr.appendChild(td);

           (td
             =w.regs_id[i]
             =dcE("TD")).className=c[0];
//           td.innerHTML="u"; // change_profile calls redisReg  will be removed soon thanks to initialisation
           edit_text.register(td, {
             size:10, maxsize:33,
             defaultValue: "0",
             check: sim.checkRegister,
             func:  sim.validRegister
           });
           td.rn=i; // used later so the proper register gets written
         tr.appendChild(td);

         tr.appendChild(dcE("TD"));

         if(+i & 1)
           tb.appendChild(tr);
       };

      function flag(name){
        tr.appendChild(dcE("TD"));
           (td=dcE("TD")).colSpan=2;
          td.innerHTML=name+":";
          (e=dcE("INPUT")).type="checkbox";
          e.onchange=sim["click"+name];
          td.onclick=sim["display"+name];
          td.style.cursor="pointer";
          td.appendChild(
             w[name+"_id"]=e);
        tr.appendChild(td);
        tr.appendChild(dcE("TD"));
      }

      tr=dcE("TR");
        flag("Carry");
        flag("Zero");
      tb.appendChild(tr);

      (d=dcE("DIV")).appendChild(tt);

      d.appendChild(e=dcE("FORM"));
        e.style.fontSize="70%";
        f='<input type="radio" name="rb" onclick="sim.chBase(this)" value=';
        e.innerHTML=I8N("rdx")
           +f+'"bin"/> bin &nbsp;'
           +f+'"dec"/> dec &nbsp;'
           +f+'"hex" checked="checked"/> hex &nbsp;';
    h3("rgs");
    w.num_func=sim.num_hex;

/////// Breakpoints
      function newBP(text,fun,i){
        (e=dcE("DIV")).innerHTML='<i>(<span id="active"></span>/<span id="total"></span>)</i>&nbsp; '+text;
         e.className="simBP";
           (f=dcE("DIV")).onclick=fun;
            f.className="plus";
            f.title="Create a new breakpoint";
         e.appendChild(f);
         e.onclick=sim.showhideNext;
        d.appendChild(e);
        d.appendChild(f
           =w[i]=dcE("DIV"));
         f.style.display="block";
         (f.active_id=getById("active","SPAN",e)).innerHTML=f.active
        =(f.total_id =getById("total" ,"SPAN",e)).innerHTML=f.total
           =0;
      }

      (d=dcE("DIV")).style.display="block";
    w.BPdiv=d;
        newBP("stop at cycle :",sim.click_addBr_cycle,"BPcycle_id");                // blacklist(BPcycle_id)....
        newBP("stop at instruction address :",sim.click_addBr_addr,"BPaddr_id");
        newBP("stop on register write :",sim.click_addBr_valReg, "BPvalReg_id");
    h3("brk");


      (d=dcE("DIV")).innerHTML="(to be created soon)";
       d.style.display="none"; ////////////////////////////////////////////////////////////////
    h3("trc");


      (d=dcE("DIV")).innerHTML="(to be created soon)";
       d.style.display="none"; ////////////////////////////////////////////////////////////////
    h3("mem");

///////////////////////////// ugly dev stuff here /////////////////////////////
/*
//        sel.disabled=true;// when using an external core
//    sim.change_profile("microYASEP",w);

// this checks that arbitrary new profiles will update the selector
     (d=dcE("BUTTON")).innerHTML="flof";
     d.onclick=function(){
       sim.change_profile("flof",w);
     }
   h3("ctl");

      (d=dcE("DIV")).innerHTML="test";
     w.prof=d; //!!
   h3("ctl");

//    sim.updateASM(w); // hide
//    sim.updateASM(w,0x84); // triggers an error
    sim.updateASM(w,123456789); // disassemble
*/


////////// créer un breakpoint par programme ici :


    // done at the end so it updates the display
    (sel.onfocus=sim.update_proflist)(0,sel);
    (sel.onchange=sim.change_profile)(0,w); // calls sim.redisReg(w);
    sim.resetState(0,w);

/*
  sim.regWrite(w,3,42);
  sim.regWrite(w,4,3456);
  sim.regWrite(w,7,12345678);


  sim.regWrite(w,-7,-5); // parking
  sim.regWrite(w,-5,-3); // parking
  sim.regWrite(w,-3,-4); // parking
  sim.regWrite(w,-1,-1); // parking
*/
sim.updateASM(w,123456789); // disassemble

    w.simCount=sim.simCount++;
    return w;
  },

  init_obj: function(){
    var i,
      r="any less equal more different".split(" ");

    for (i in sim.states)
      sim[sim.states[i]]=i;

    sim.regSel=dcE("SELECT");
    for (i in Y.registers_names)
      sim.regSel.options[i]=new Option(Y.registers_names[i]);

    sim.relSel=dcE("SELECT");
    for (i in r)
      sim.relSel.options[i]=new Option(r[i]);
 
    menu.subMenuItem(menu.list["Tools"],i8n.sim, "tool/YASim");
  }

});
